//---------------------------------------------------------------------------

#include <vcl.h>
#include <iterator>
#include "algostuff.hpp"

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

int main()
{
  vector<int> coll;

  INSERT_ELEMENTS(coll,3,7);
  INSERT_ELEMENTS(coll,5,9);
  INSERT_ELEMENTS(coll,1,4);

  PRINT_ELEMENTS (coll," :\n");

  //    
  make_heap (coll.begin(), coll.end());

  PRINT_ELEMENTS (coll, "  make_heap():\n");

  //     
  pop_heap (coll.begin(), coll.end());
  coll.pop_back();

  PRINT_ELEMENTS (coll, "  pop_heap():\n");

  //     
  coll.push_back (17);
  push_heap (coll.begin(), coll.end());

  PRINT_ELEMENTS (coll, "  push_heap():\n");

  //     
  //   - :      
  sort_heap (coll.begin(), coll.end());

  PRINT_ELEMENTS (coll, "  sort_heap():\n");


  getch();
  return 0;
}

//---------------------------------------------------------------------------